function varargout = can_gui(varargin)
% CAN_GUI MATLAB code for can_gui.fig
%      CAN_GUI, by itself, creates a new CAN_GUI or raises the existing
%      singleton*.
%
%      H = CAN_GUI returns the handle to a new CAN_GUI or the handle to
%      the existing singleton*.
%
%      CAN_GUI('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in CAN_GUI.M with the given input arguments.
%
%      CAN_GUI('Property','Value',...) creates a new CAN_GUI or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before can_gui_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to can_gui_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help can_gui

% Last Modified by GUIDE v2.5 21-Jul-2017 11:34:33

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @can_gui_OpeningFcn, ...
                   'gui_OutputFcn',  @can_gui_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before can_gui is made visible.
function can_gui_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to can_gui (see VARARGIN)

% Choose default command line output for can_gui
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

% Open Simulation
open_system('CAN_Communication');

value = get_param('CAN_Communication/Gain','Gain');
set(handles.slider_gain,'Value',str2num(value));
% UIWAIT makes can_gui wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = can_gui_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


% --- Executes on button press in pushbutton_start.
function pushbutton_start_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton_start (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
set_param('CAN_Communication','SimulationCommand','Start');

% --- Executes on button press in pushbutton_stop.
function pushbutton_stop_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton_stop (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
set_param('CAN_Communication', 'SimulationCommand', 'Stop');

ph1 = handles.axes_can.Children;
if ishandle(ph1)
        for k=1:3
        ph1(k).XData = [];
        ph1(k).YData = [];
        end
end

% --- Executes on button press in pushbutton_end.
function pushbutton_end_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton_end (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
clear all
% clear Workspace
evalin('base','clear');
% Closes Simulink model unconditionally
bdclose('CAN_Communication')
% Closes GUI
close can_gui


% --- Executes on slider movement.
function slider_gain_Callback(hObject, eventdata, handles)
% hObject    handle to slider_gain (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'Value') returns position of slider
%        get(hObject,'Min') and get(hObject,'Max') to determine range of slider
value = get(hObject,'Value');
set(handles.edit_gain,'String',num2str(value));
% Update the model's gain value
set_param('CAN_Communication/Gain','Gain',num2str(value));

% Update simulation if the model is running
status = get_param('CAN_Communication','simulationstatus');
if strcmp(status,'running')
    set_param('CAN_Communication','simulationCommand','Update');
end

% --- Executes during object creation, after setting all properties.
function slider_gain_CreateFcn(hObject, eventdata, handles)
% hObject    handle to slider_gain (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end



function edit_value_Callback(hObject, eventdata, handles)
% hObject    handle to edit_value (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_value as text
%        str2double(get(hObject,'String')) returns contents of edit_value as a double


% --- Executes during object creation, after setting all properties.
function edit_value_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_value (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit_gain_Callback(hObject, eventdata, handles)
% hObject    handle to edit_gain (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_gain as text
%        str2double(get(hObject,'String')) returns contents of edit_gain as a double
edit_string = get(hObject, 'String');
edit_value = str2num(edit_string);
if ((0<edit_value) && (edit_value<10))
    set(handles.slider_gain, 'Value', edit_value);
end

% Update the model's gain value
set_param('CAN_Communication/Gain','Gain',num2str(edit_value));

% Update simulation if the model is running
status = get_param('CAN_Communication','simulationstatus');
if strcmp(status,'running')
    set_param('CAN_Communication','simulationCommand','Update');
end

% --- Executes during object creation, after setting all properties.
function edit_gain_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_gain (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
